/* Definitions of target machine for GNU compiler.
   Renesas H8/300 version generating elf
   Copyright (C) 2001, 2002, 2003, 2004 Free Software Foundation, Inc.
   Contributed by Steve Chamberlain (sac@cygnus.com),
   Jim Wilson (wilson@cygnus.com), and Doug Evans (dje@cygnus.com).

This file is part of GCC.

GCC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GCC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to
the Free Software Foundation, 51 Franklin Street, Fifth Floor,
Boston, MA 02110-1301, USA.  */

#ifndef GCC_H8300_ELF_H
#define GCC_H8300_ELF_H

#undef  ENDFILE_SPEC
#define ENDFILE_SPEC "crtend.o%s %{pg:gcrtn.o%s}%{!pg:crtn.o%s}"

#undef	STARTFILE_SPEC
#define STARTFILE_SPEC "%{!shared: \
			 %{!symbolic: \
			  %{pg:gcrt0.o%s}%{!pg:%{p:mcrt0.o%s}%{!p:crt0.o%s}}}}\
			%{pg:gcrti.o%s}%{!pg:crti.o%s} \
			crtbegin.o%s"

#undef USER_LABEL_PREFIX
#define USER_LABEL_PREFIX "_"

#define JUMP_TABLES_IN_TEXT_SECTION (flag_pic)

/* use a more compact format for line information */
#define DWARF2_ASM_LINE_DEBUG_INFO 1

#undef LINK_SPEC
#define LINK_SPEC "%{mh:%{mn:-m h8300hnelf}} %{mh:%{!mn:-m h8300helf}} %{ms:%{mn:-m h8300snelf}} %{ms:%{!mn:-m h8300self}} %{msx:%{mn:-m h8300sxnelf;:-m h8300sxelf}}"
#undef  TARGET_ASM_SELECT_SECTION
#define TARGET_ASM_SELECT_SECTION  h8300_select_section

#define TINY_DATA_SECTION_ASM_OP	"\t.section\t.tinydata,\"aw\""
#define TINY_BSS_SECTION_ASM_OP	"\t.section\t.tinybss,\"aw\""
#define TINY_RODATA_SECTION_ASM_OP	"\t.section\t.tinyrodata,\"a\""

#define EXTRA_SECTIONS in_tinydata, in_tinyrodata,in_tinybss

extern void tiny_rodata_section(void);
extern void tiny_data_section(void);
extern void tiny_bss_section(void);

#define EXTRA_SECTION_FUNCTIONS		\
 	TINY_RODATA_SECTION_FUNCTION	\
	TINY_DATA_SECTION_FUNCTION	\
	TINY_BSS_SECTION_FUNCTION

#define TINY_RODATA_SECTION_FUNCTION   \
void                                   \
tiny_rodata_section()                  \
{                                      \
  if (in_section != in_tinyrodata)     \
    {                                  \
      fprintf (asm_out_file, "%s\n", TINY_RODATA_SECTION_ASM_OP); \
      in_section=in_tinyrodata;        \
    }                                  \
}
 
#define TINY_DATA_SECTION_FUNCTION     \
void                                   \
tiny_data_section()                    \
{                                      \
  if (in_section != in_tinydata)       \
    {                                  \
      fprintf (asm_out_file, "%s\n", TINY_DATA_SECTION_ASM_OP); \
      in_section = in_tinydata;        \
    }                                  \
}

#define TINY_BSS_SECTION_FUNCTION      \
void                                   \
tiny_bss_section()                     \
{                                      \
  if (in_section != in_tinybss)        \
    {                                  \
      fprintf (asm_out_file, "%s\n", TINY_BSS_SECTION_ASM_OP); \
      in_section = in_tinybss;         \
    }                                  \
}
													
#endif /* h8300/elf.h */
